import { Benchmark, BenchmarkParams, BenchmarkMeta, ITab } from "../benchmark";
export declare type PhaseSample = {
    phase: string;
    self: number;
    cumulative: number;
};
export declare type RequestSample = {
    url: string;
    response: number;
    duration: number;
};
export declare type GCSample = {
    duration: number;
    usedHeapSizeBefore: number;
    usedHeapSizeAfter: number;
};
export declare type InterationSample = {
    duration: number;
    phaseSamples: PhaseSample[];
    js: number;
    compile: number;
    run: number;
    gc: number;
    gcSamples: GCSample[];
    net: number;
    response: number;
    requestSamples: RequestSample[];
};
export declare type InitialRenderSamples = {
    meta: BenchmarkMeta;
    set: string;
    samples: InterationSample[];
};
export interface Marker {
    /**
     * window.performance.mark
     */
    start: string;
    /**
     * Label of phase
     */
    label: string;
}
export interface InitialRenderBenchmarkParams extends BenchmarkParams {
    /**
     * URL to measure initial render of.
     */
    url: string;
    markers: Marker[];
}
export declare class InitialRenderBenchmark extends Benchmark<InitialRenderSamples> {
    protected params: InitialRenderBenchmarkParams;
    constructor(params: InitialRenderBenchmarkParams);
    createResults(meta: BenchmarkMeta): InitialRenderSamples;
    performIteration(t: ITab, results: InitialRenderSamples, i: number): Promise<void>;
}
