"use strict";
const trace_event_1 = require("./trace_event");
class Bounds {
    constructor() {
        this.min = 0;
        this.max = 0;
        this.empty = true;
    }
    addValue(value) {
        if (this.empty) {
            this.empty = false;
            this.min = this.max = value;
        }
        else {
            this.max = Math.max(this.max, value);
            this.min = Math.min(this.min, value);
        }
    }
    addEvent(event) {
        this.addValue(event.ts);
        if (event.ph === trace_event_1.TRACE_EVENT_PHASE_COMPLETE) {
            let end = event.ts + event.dur;
            this.addValue(end);
        }
    }
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Bounds;
//# sourceMappingURL=bounds.js.map