"use strict";
const thread_1 = require("./thread");
const bounds_1 = require("./bounds");
class Process {
    constructor(id) {
        this.threadMap = {};
        this.threads = [];
        this.mainThread = null;
        this.bounds = new bounds_1.default();
        this.events = [];
        this.id = id;
    }
    thread(tid) {
        let thread = this.threadMap[tid];
        if (thread === undefined) {
            this.threadMap[tid] = thread = new thread_1.default(tid);
            this.threads.push(thread);
        }
        return thread;
    }
    addEvent(event) {
        this.bounds.addEvent(event);
        this.events.push(event);
        this.thread(event.tid).addEvent(event);
    }
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = Process;
//# sourceMappingURL=process.js.map