import Process from "./process";
import Thread from "./thread";
import Bounds from "./bounds";
import { TraceEvent } from "./trace_event";
export default class Trace {
    processMap: {
        [pid: number]: Process;
    };
    processes: Process[];
    mainProcess: Process;
    bounds: Bounds;
    events: TraceEvent[];
    browserProcess: Process;
    gpuProcess: Process;
    rendererProcesses: Process[];
    numberOfProcessors: number;
    process(pid: number): Process;
    thread(pid: number, tid: number): Thread;
    addEvents(events: TraceEvent[]): void;
    addEvent(event: TraceEvent): void;
    addMetadata(event: TraceEvent): void;
}
